#include <bits/stdc++.h>
using ll = long long;
using namespace std;

ll bin_pow(int k, int n){
    vector<ll> d;
    ll dv = k;
    ll res = 1;
    while(n != 1){
        if(n % 2 == 1){
            res *= dv;
        }
        dv *= dv;
        n /= 2;
    }
    res *= dv;
    return res;
}

ll good(int t, vector<int> a, vector<int> b, ll m){
    ll kol = 0;
    for(int i = 0; i < a.size(); i++){
        if(a[i] <= t){
            int dt = (t - a[i]);
            if(dt >= b[i]){
                kol += (bin_pow(2, dt - b[i] + 1));
            }
            else{
                kol += 1;
            }
        }
    }
    return kol;
}

void solve(){
    ll n, m;
    cin >> n >> m;

    vector<int> a(n), b(n);

    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    for(int i = 0; i < n; i++){
        cin >> b[i];
    }

    int l = 0, r = 1;

    while(good(r, a, b, m) < m) r *= 2;

    while(l + 1 < r){
        int mid = (l + r) / 2;
        if(good(mid, a, b, m) >= m){
            r = mid;
        }
        else{
            l = mid;
        }
    }

    if(good(r, a, b, m) < m){
        cout << -1;
        return;
    }

    if(good(l, a, b, m) == m){
        cout << l;
    }
    else if(good(r, a, b, m) == m){
        cout << r;
    }
    else{
        cout << -1;
    }

}

signed main() {
    int tt = 1;
    while(tt--) solve();
}
